; ADS Freescale Library Netlists
;***************************************************************
; IC product internal components
;***************************************************************
FSL_TECH_CALC_PAD_Area(w,s,nf) = w*s*nf;
FSL_TECH_GetGroup(t)=if(t==0) then "m1" elseif(t==1) then "m2" else "m1m2" endif
FSL_TECH_CAP_VAL_M2 = 7.498e-6 ; was 5.25e-6
FSL_TECH_CALC_PAD_CAP(Area) = (Area*FSL_TECH_CAP_VAL_M2); 

; Calculate Metal-2 pad Res in Ohms, where Area is in mks**2
FSL_TECH_RSHUNT_M2 = 1.44e-9  ; was 4.78e-8
FSL_TECH_CALC_PAD_RES(Area) = (FSL_TECH_RSHUNT_M2/Area)

;*************************************************
define FSL_TECH_TLINE (_net1 _net2)
parameters GLINE=0.0 RLINE=0.0 Ohms CLINE=1 pF LLINE= 1pH Length=100 um
TLM1_FREQ=if( freq==0.0) then 1.0 else freq endif
LINEY=complex(GLINE,TLM1_FREQ*2.0*pi*CLINE)
LINEZ=complex(RLINE,TLM1_FREQ*2.0*pi*LLINE)
GAMMA=sqrt(LINEZ*LINEY)
Zo=sqrt(LINEZ/LINEY)
MYARG=GAMMA*Length
TLM1_A=if (freq==0.0) then (complex(1.0,0.0)) else (cosh(MYARG)) endif
TLM1_B=if (freq==0.0) then (complex(RLINE*Length,0.0)) else (Zo*sinh(MYARG)) endif
TLM1_C=if (freq==0.0) then (complex(0.0,0.0)) else ((1/Zo)*sinh(MYARG)) endif
TLM1_D=if (freq==0.0) then (complex(1.0,0.0)) else (cosh(MYARG)) endif
Chain:Chain2  _net1 0 _net2 0 A=TLM1_A B=TLM1_B C=TLM1_C D=TLM1_D 

end FSL_TECH_TLINE
;**********************************************************************
FSL_TECH_M1_C0 = 8.55941e-11
FSL_TECH_M2_C0 = 7.3765e-11
FSL_TECH_M1M2_C0 = 9.03845e-11
FSL_TECH_M1_C1 = 1.19648e-5
FSL_TECH_M2_C1 = 7.49869e-6
FSL_TECH_M1M2_C1 = 1.21381e-5
FSL_TECH_M1_GX0 = 4.5e-6
FSL_TECH_M2_GX0 = 8.0e-6
FSL_TECH_M1M2_GX0 = 6.0e-6
FSL_TECH_M1_GY0 = 2.6862e-6
FSL_TECH_M2_GY0 = 5.936644e-7
FSL_TECH_M1M2_GY0 = 7.20254e-6
FSL_TECH_M1_GY1 = -1.66797
FSL_TECH_M2_GY1 = -1.819543
FSL_TECH_M1M2_GY1 = -1.5294
FSL_TECH_M1_GLE = 3
FSL_TECH_M2_GLE = 3
FSL_TECH_M1M2_GLE = 2
FSL_TECH_M1_W1 = 1.5e-6
FSL_TECH_M2_W1 = 3.6e-6
FSL_TECH_M1M2_W1 = 5.1e-6
FSL_TECH_M1_RBIAS = 0.2e-6
FSL_TECH_M2_RBIAS = 0.6e-6
FSL_TECH_M1M2_RBIAS = 0.2e-6
FSL_TECH_M1_RSHDC = 0.025
FSL_TECH_M2_RSHDC = 0.01
FSL_TECH_M1M2_RSHDC = 0.007
FSL_TECH_M1_RFS0 = 0.0408868
FSL_TECH_M2_RFS0 = 0.1122275
FSL_TECH_M1M2_RFS0 = 0.18092911
FSL_TECH_M1_RFS1 = 0.8
FSL_TECH_M2_RFS1 = 0.6
FSL_TECH_M1M2_RFS1 = 1.0
FSL_TECH_M1_RFS2 = -0.83121917
FSL_TECH_M2_RFS2 = -0.8136852
FSL_TECH_M1M2_RFS2 = -0.84091421
;**********************************************************************
define FSL_TECH_TLINE_PRE (_net1 _net2)
parameters W=30 um L=100 um T=25 GROUP="m1"

Width=(W)
Length=(L)
Temp=(T)
Group=(GROUP)
Tnom=(25.0)
Tcm=(0.0032)
TL_FREQ=if( freq==0.0) then 1.0 else freq endif

C0_val = if(Group=="m1") then FSL_TECH_M1_C0  \
	 elseif(Group=="m2") then FSL_TECH_M2_C0 else FSL_TECH_M1M2_C0 endif
C1_val = if(Group=="m1") then FSL_TECH_M1_C1  \
	 elseif(Group=="m2") then FSL_TECH_M2_C1 else FSL_TECH_M1M2_C1 endif
CLINE=(C0_val+C1_val*Width)

GX0_val = if(Group=="m1") then FSL_TECH_M1_GX0  \
	 elseif(Group=="m2") then FSL_TECH_M2_GX0 else FSL_TECH_M1M2_GX0 endif
Gx=(1e-6/(Width+GX0_val))

GY0_val = if(Group=="m1") then FSL_TECH_M1_GY0  \
	 elseif(Group=="m2") then FSL_TECH_M2_GY0 else FSL_TECH_M1M2_GY0 endif
GY1_val = if(Group=="m1") then FSL_TECH_M1_GY1 \
	 elseif(Group=="m2") then FSL_TECH_M2_GY1 else FSL_TECH_M1M2_GY1 endif
Gy=(GY0_val*(Gx**(GY1_val)))
GLE_val = if(Group=="m1") then FSL_TECH_M1_GLE  \
	 elseif(Group=="m2") then FSL_TECH_M2_GLE else FSL_TECH_M1M2_GLE endif
GLINE=(Gy*(TL_FREQ*1.0e-9)**GLE_val)

W1_val = if(Group=="m1") then FSL_TECH_M1_W1  \
	 elseif(Group=="m2") then FSL_TECH_M2_W1 else FSL_TECH_M1M2_W1 endif
Wind = (Width+W1_val)
Dsub=((80.0 - 2.7e-9*(TL_FREQ))*1.0e-6)
Drat=(2.0*Dsub/Wind)
LLINE=(1.0e-7*(ln(Drat**2+1.0)-Drat**2*ln(1+1/Drat**2)+4.0*Drat*atan(1/Drat)))

RMBIAS_val = if(Group=="m1") then FSL_TECH_M1_RBIAS  \
	 elseif(Group=="m2") then FSL_TECH_M2_RBIAS else FSL_TECH_M1M2_RBIAS endif
RSHDC_val = if(Group=="m1") then FSL_TECH_M1_RSHDC  \
	 elseif(Group=="m2") then FSL_TECH_M2_RSHDC else FSL_TECH_M1M2_RSHDC endif
RFS0_val = if(Group=="m1") then FSL_TECH_M1_RFS0  \
	 elseif(Group=="m2") then FSL_TECH_M2_RFS0 else FSL_TECH_M1M2_RFS0 endif
RFS1_val = if(Group=="m1") then FSL_TECH_M1_RFS1  \
	 elseif(Group=="m2") then FSL_TECH_M2_RFS1 else FSL_TECH_M1M2_RFS1 endif
RFS2_val = if(Group=="m1") then FSL_TECH_M1_RFS2  \
	 elseif(Group=="m2") then FSL_TECH_M2_RFS2 else FSL_TECH_M1M2_RFS2 endif
	 
RfitOffset=(-1.2)
RfitExpCo=(0.42)
RfitSlope=(RFS0_val/(Width*1.0e6-RFS1_val)**(RFS2_val))
RfitExp=(exp(RfitOffset+RfitExpCo*TL_FREQ*1.0e-9))
Rfit=(RSHDC_val*(1+RfitSlope*TL_FREQ*1.0e-9*RfitExp/(1+RfitExp)))
RfitTadj=(Rfit+Tcm*(Temp-Tnom)*RSHDC_val)
RLINE=(RfitTadj/(Width+RMBIAS_val))

FSL_TECH_TLINE:T1 _net1 _net2 GLINE=GLINE RLINE=RLINE  \
		CLINE=CLINE LLINE=LLINE Length=Length

end FSL_TECH_TLINE_PRE

;********** FSL_ML   ***********
define FSL_ML_TI_v1p0(_net1 _net2)
parameters Line_Length=20.0 um Port_Width=10.0 um Metal_Type=1 LocalTemp=25

Group=FSL_TECH_GetGroup(Metal_Type)
FSL_ML_TEMP = if(LocalTemp==25) then (25.0) else (LocalTemp) endif
FSL_TECH_TLINE_PRE:FSL_ML1 _net1 _net2 L=Line_Length W=Port_Width GROUP=Group T=FSL_ML_TEMP
end FSL_ML_TI_v1p0
;********** FSL_ML   ***********

;*******************************************************************************************************
define FSL_FET_Gate_Pad_ECP ( _net24  _net234  _net203 ) 
parameters  FS="F130P"  Size=20.4  NumF=34  Manifold_Width=20 um  SD_Spacing=30.0 um 
Pad_Length=Manifold_Width*1e6
New_SD_Spacing= SD_Spacing*1e6

Rfreq_F130P =3.25199
F130P_Rseries_0 =-.5;-0.440065
F130P_Rseries_1 =-0.25
F130P_Cseries_0 =0.5
F130P_Cseries_1 =0.23

F131P_Rseries_0 =0.5;0.658649
F131P_Rseries_1 =-0.25
F131P_Cseries_0 =0.5
F131P_Cseries_1 =0.23

F148P_Rseries_0 =0.00001
F148P_Rseries_1 =1.0e-8
F148P_Cseries_0 =0.0001
F148P_Cseries_1 =0.0001

Rfreq_F131P =0.40712

Rfreq_F148P =0.001

Size_base =2.4
Area1 = Size/Size_base
Rseries_0 = if(FS=="F130P") then F130P_Rseries_0 elseif(FS=="F131P") then F131P_Rseries_0 else F148P_Rseries_0 endif
Rseries_1 = if(FS=="F130P") then F130P_Rseries_1 elseif(FS=="F131P") then F131P_Rseries_1 else F148P_Rseries_1 endif
Cseries_0 = if(FS=="F130P") then F130P_Cseries_0 elseif(FS=="F131P") then F131P_Cseries_0 else F148P_Cseries_0 endif
Cseries_1 = if(FS=="F130P") then F130P_Cseries_1 elseif(FS=="F131P") then F131P_Cseries_1 else F148P_Cseries_1 endif
Rseries = Rseries_0 + Rseries_1/Area1
Cseries = Cseries_0 + Cseries_1*Area1

Rfreq = if(FS=="F130P") then Rfreq_F130P elseif(FS=="F131P") then Rfreq_F131P else Rfreq_F148P endif
NumLines=int(NumF)/2 + 1
Pad_Width = New_SD_Spacing*NumF + LineWidth
LineWidth1 = 6
LineWidth = 4
GateLineWidth = if(FS=="F148P") then 1 else ((NumLines-2)*LineWidth1 + 2*LineWidth) endif
GateFeedLength= if(FS=="F148P") then 1 else 44 endif
GateLineLength = GateFeedLength
Area = FSL_TECH_CALC_PAD_Area(Pad_Length*1e-6,New_SD_Spacing*1e-6,NumF)
Cpadv=FSL_TECH_CALC_PAD_CAP(Area)
Rpadv=FSL_TECH_CALC_PAD_RES(Area)
C:C1  _net24 _net8 C=Cpadv F 
R:R1  _net8 _net203 R=Rpadv Ohm Noise=yes
Z_Port:Z1P1  _net233 _net234 Z[1,1]=Rseries + Rfreq*1e-10*freq 
C:L1  _net234 0 C=Cseries pF 
;R:R3 _net24 _net233 R=0.001
FSL_ML_TI_v1p0:M4  _net24 _net233  \
	Line_Length=GateLineLength um  \
	Port_Width=GateLineWidth um  \
	Metal_Type=1 
end FSL_FET_Gate_Pad_ECP
;*******************************************************************************************************
define FSL_FET_Drain_Pad_ECP ( _net1  _net2 _net3 ) 
parameters  FS="F130P"  Size=20.4  NumF=34  Manifold_Width=0.5 um  SD_Spacing=30.0 um 
Pad_Length=Manifold_Width*1e6
New_SD_Spacing= SD_Spacing*1e6
NumLines=int(NumF)/2
Pad_Width = New_SD_Spacing*NumF + LineWidth
LineWidth = 4
DrainLineWidth = if(FS=="F148P") then 1 else (NumLines-1)*LineWidth + 2*14 endif
DrainFeedLength= if(FS=="F148P") then 1 else 36 endif
DrainLineLength = DrainFeedLength
Area = FSL_TECH_CALC_PAD_Area(Pad_Length*1e-6,New_SD_Spacing*1e-6,NumF)
Cpadv=FSL_TECH_CALC_PAD_CAP(Area)
Rpadv=FSL_TECH_CALC_PAD_RES(Area)
;R:R3 _net2 _net1 R=0.001
FSL_ML_TI_v1p0:M4  _net2 _net1 Line_Length=DrainLineLength um Port_Width=DrainLineWidth um Metal_Type=1 
R:R1  _net2 _net4 R=Rpadv Ohm Noise=yes 
C:C1  _net4 _net3 C=Cpadv F 
end FSL_FET_Drain_Pad_ECP
;*******************************************************************************************************

;************FSL_TECH_FET_ROOT *******
define FSL_TECH_FET_ROOT (gate_pad drain_pad src thermal)
parameters FS="130P" Gate_Fingers=34 Gate_Periphery=20.4 mm Drain_Manifold_Width=0.5 um  \
	File="F130_ROOT_Plastic.mds" 

Options:Options1 Temp=25 TopologyCheck=yes ForceS_Params=yes ForceM_Params=yes \
	MaxSpectralSize=512 V_RelTol=1e-6 V_AbsTol=1e-6 V I_RelTol=1e-6 I_AbsTol=1e-6 A \
	GiveAllWarnings=yes MaxWarnings=10 SaveBranchCurrents=no OutputInternalNodes=no \
	DC_ReadInitialGuess=no DC_WriteFinalSolution=no 
	
FSL_NEW_LG = (0.001)
FSL_NEW_LD = (0.001)
FSL_NEW_LS = (0.001)

FSL_FET_Gate_Pad_ECP:PADS1 gate_pad gate src Size=Gate_Periphery*1.0e3 NumF=Gate_Fingers
L:Lgate gate _net10 L=FSL_NEW_LG pH
model ADSFETM1 HP_FET File=File 
"ADSFETM1":ADSFET1  _net20 _net10 _net30 Wtot=Gate_Periphery N=Gate_Fingers
L:Lsource src _net30 L=FSL_NEW_LS pH
R:Rt_DKF  thermal 0 R=50 MOhm Noise=no
L:Ldrain drain _net20 L=FSL_NEW_LD pH
FSL_FET_Drain_Pad_ECP:PADS2 drain_pad drain src Size=Gate_Periphery*1.0e3 NumF=Gate_Fingers Manifold_Width=Drain_Manifold_Width
end FSL_TECH_FET_ROOT
;************FSL_TECH_FET_ROOT *******

;************FSL_TECH_FET_MET *******
define FSL_TECH_FET_MET (gate_pad drain_pad src thermal)
parameters FS="130P" Gate_Fingers=34 Gate_Periphery=20.4 mm Drain_Manifold_Width=0.5 um \
	File="FSL_MW7IC2240N_Level2_Rev0_20.mdl" CTH=1e-7 RTH=4.8 TSNK=25 DataPath="FSL_MW7IC2240N_Data\"

Options:Options1 Temp=25 TopologyCheck=yes ForceS_Params=yes ForceM_Params=yes  \
	MaxSpectralSize=512 V_RelTol=1e-6 V_AbsTol=1e-6 V I_RelTol=1e-6 I_AbsTol=1e-6 A  \
	GiveAllWarnings=yes MaxWarnings=10 SaveBranchCurrents=no OutputInternalNodes=no  \
	DC_ReadInitialGuess=no DC_WriteFinalSolution=no

FSL_NEW_LG = (0.001)
FSL_NEW_LD = (0.001)
FSL_NEW_LS = (0.001)

FSL_FET_Gate_Pad_ECP:PADS1 gate_pad gate src Size=Gate_Periphery*1.0e3 NumF=Gate_Fingers
L:Lgate gate _net10 L=FSL_NEW_LG pH
FSLRFPK_METMOS_v1:FET1  _net10 _net20 _net30 thermal File=File TSNK=TSNK RTH=RTH CTH=CTH
L:Lsource src _net30 L=FSL_NEW_LS pH
R:Rt_DKF  thermal 0 R=500 MOhm Noise=no
L:Ldrain drain _net20 L=FSL_NEW_LD pH
FSL_FET_Drain_Pad_ECP:PADS2 drain_pad drain src Size=Gate_Periphery*1.0e3 NumF=Gate_Fingers Manifold_Width=Drain_Manifold_Width
end FSL_TECH_FET_MET
;************FSL_TECH_FET_MET *******
